/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -c -N lookup_keyword -t -D keywords.gperf  */
/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 807 $ $LastChangedDate: 2002-09-01 08:32:22 +0200 (Sun, 01 Sep 2002) $
 *
 * Keyword.gperf - List of keyword recognised by Gont compiler.
 */

#include "parser.h"
#include <string.h>
struct keyword;
struct keyword *lookup_keyword(const char*, unsigned int);
struct keyword { char *name; int tok; };

#define TOTAL_KEYWORDS 37
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 10
#define MIN_HASH_VALUE 4
#define MAX_HASH_VALUE 91
/* maximum key range = 88, duplicates = 1 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static unsigned char asso_values[] =
    {
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 10, 15, 10,
      20,  0, 25, 10, 15, 15, 92,  0, 30, 92,
      45, 25, 25, 92, 40,  0,  5,  0,  0,  0,
      92,  0, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
      92, 92, 92, 92, 92, 92
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
struct keyword *
lookup_keyword (str, len)
     register const char *str;
     register unsigned int len;
{
  static struct keyword wordlist[] =
    {
      {"else", KW_ELSE},
      {"while", KW_WHILE},
      {"try", KW_TRY},
      {"true", KW_TRUE},
      {"type", KW_TYPE},
      {"struct", KW_STRUCT},
      {"as", KW_AS},
      {"case", KW_CASE},
      {"string", KW_STRING},
      {"continue", KW_CONTINUE},
      {"with", KW_WITH},
      {"break", KW_BREAK},
      {"switch", KW_SWITCH},
      {"int", KW_INT},
      {"void", KW_VOID},
      {"skip", KW_SKIP},
      {"false", KW_FALSE},
      {"finally", KW_FINALLY},
      {"float", KW_FLOAT},
      {"typedef", KW_TYPEDEF},
      {"let", KW_LET},
      {"opt_struct", KW_OPT_STRUCT},
      {"if", KW_IF},
      {"raise", KW_RAISE},
      {"do", KW_DO},
      {"def", KW_DEF},
      {"bool", KW_BOOL},
      {"union", KW_UNION},
      {"extern", KW_EXTERN},
      {"section", KW_SECTION},
      {"exception", KW_EXCEPTION},
      {"in", KW_IN},
      {"for", KW_FOR},
      {"fun", KW_FUN},
      {"open", KW_OPEN},
      {"null", KW_NULL},
      {"return", KW_RETURN}
    };

  static short lookup[] =
    {
       -1,  -1,  -1,  -1,   0,   1,  -1,  -1,   2, -63,
       -1,   5,   6,  -1,   7,  -1,   8,  -1,   9,  10,
       11,  12,  -1,  13,  14, -34,  -2,  -1,  -1,  15,
       16,  -1,  17,  -1,  -1,  18,  -1,  19,  20,  -1,
       21,  -1,  22,  -1,  -1,  23,  -1,  24,  25,  26,
       27,  28,  29,  -1,  30,  -1,  -1,  -1,  -1,  -1,
       -1,  -1,  31,  -1,  -1,  -1,  -1,  -1,  32,  -1,
       -1,  -1,  -1,  33,  34,  -1,  -1,  -1,  -1,  35,
       -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
       -1,  36
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index].name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return &wordlist[index];
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register struct keyword *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register struct keyword *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  register const char *s = wordptr->name;

                  if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                    return wordptr;
                  wordptr++;
                }
            }
        }
    }
  return 0;
}
