/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 830 $ $LastChangedDate: 2002-09-01 12:26:56 +0200 (Sun, 01 Sep 2002) $
 *
 * Standard library for Gont, Hacks module interface.
 *
 * This module contains various ugly hacks.
 */

/** Hacks module, as the name suggests, provides various more or less ugly
    hacks.  It serves as an escape from strict Gont typesystem.  */

/* Return [x] coerced to integer. For complex types (structures, unions)
   it is address of object in the memory, hence the name.  Returned value
   is not guaranteed to be positive, nor to be the same each time program
   is run.  */
int ptr_of('a x) = "Hacks__ptr_of";

/* Same as [ptr_of(x) == ptr_of(y)].  */
bool same_ptrs('a x, 'a y) = "Hacks__same_ptrs";

/* Given arbitrary object [u] of union type, return its tag. Union tag is
   positive integer.  Tags are assigned in ascending order, starting from
   1, as fields of union are defined in source file.  This function is
   unsafe if applied to something that is not an union.  */
int union_tag('a u) = "Hacks__union_tag";

/* Given [x] of type ['b] return it, with type coerced to ['a].  It is 
   identity function.  This function is unsafe.  */
'a cast('b x) = "Hacks__cast";

/* Return [true] iff representation of [x] is same as representation of
   [null].  */
bool is_null('a x) = "Hacks__is_null";
