/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Standard library for Gont, Int64 module implementation.
 */

open Int64;

t zero;
t one;
t minus_one;

t succ(t x)
{
	return add(x, one);
}

t pred(t x)
{
	return sub(x, one);
}

t of_int(int x)
{
	return of_string(itoa(x));
}

section init 
{
	zero = of_int(0);
	one = of_int(1);
	minus_one = of_int(-1);
}
