/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 632 $ $LastChangedDate: 2002-08-28 01:51:04 +0200 (Wed, 28 Aug 2002) $
 *
 * Standard library for Gont, String module interface.
 */

// Same as ==.
bool eq(string, string) = "gont_streq";

// One can also use <, >, >=, ...
int cmp(string, string) = "gont_strcmp";

// Same as +.
string join(string, string) = "gont_strjoin";

// This is constant time operation.
int length(string) = "String__length";

// Return fresh copy of given string.
string copy(string) = "String__copy";

string sub(string s, int pos, int len) = "String__sub";
char get(string s, int idx) = "String__get";
void set(string s, int idx, char c) = "String__set";
string create(int n) = "String__create";
string make(int n, char c);
void fill(string s, int pos, int len, char c) = "String__fill";
void blit(string src, int srcoff, string dst, int dstoff, int len) 
	= "String__blit";
	
string concat(string sep, <string>list lst);
void iter(*(void (char)) f, string s);
int index(string s, char c);
int rindex(string s, char c);
int index_from(string s, int pos, char c);
int rindex_from(string s, int pos, char c);
bool contains(string s, char c);
bool contains_from(string s, int pos, char c);
bool rcontains_from(string s, int pos, char c);

int index_str(string heystack, string needle);
int index_str_from(string heystack, int pos, string needle);
bool contains_str(string heystack, string needle);
bool contains_str_from(string heystack, int pos, string needle);

<string>list split(string sep, string s);

// easy conversion to const char *
type cstring;
cstring to_cstring(string) = "String__to_cstring";

// raise Invalid_argument "String::of_cstring" of cstring is NULL
string of_cstring(cstring) = "String__of_cstring";

char uppercase_char(char) = "String__uppercase_char";
char lowercase_char(char) = "String__lowercase_char";
string capitalize(string s);
string uncapitalize(string s);

int hash(string) = "gont_hash_string";
