// Test polimorphic unions
// $Rev: 758 $ $LastChangedDate: 2002-08-31 16:04:39 +0200 (Sat, 31 Aug 2002) $

union <'a>xlist {
	void Xnil;
	*('a, <'a>xlist) Xcons;
}

int length(<'a>xlist l)
{
	switch l {
	case Xnil():
		return 0;
	case Xcons(hd, tl):
		return 1 + length(tl);
	}
}

void iter(*(void ('a)) f, <'a>xlist l)
{
	switch l {
	case Xnil():
		return;
		
	case Xcons(hd, tl):
		f(hd);
		iter(f, tl);
	}
}

<'b>xlist map(*('b ('a)) f, <'a>xlist l)
{
	switch l {
	case Xnil():
		return Xnil();		

	case Xcons(hd, tl):
		return Xcons(f(hd), map(f, tl));
	}
}

string i2s(int i)
{
	switch i {
	case 10:
		return "ten";
	case 20:
		return "twenty";
	case x:
		return "hgw";
	}
}

section init
{
	<int>xlist i;
	<string>xlist s;
	
	i = Xcons(1, Xcons(10, Xcons(20, Xnil)));
	s = Xcons("foo", Xcons("bar", Xcons("baz", Xnil())));

	iter(print_int, i);
	print_string(".");
	iter(print_string, s);
	print_string(".");
	iter(print_string, map(i2s, i));
	print_string(".");
	
	print_int(length(i));
	print_string(".");
	print_int(length(s));
	print_string(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 11020.foobarbaz.hgwtentwenty.3.3.
 */
